;;;; run-testbase.scm (run.scm)

(use utils posix)

;;; Constants & Procedures

(define *verbose* #t)

(define REPOSITORY-DIRECTORY (repository-path))

;; These must be kept in synch w/ testbase-results.scm!

(define TESTBASE-DIRECTORY (make-pathname REPOSITORY-DIRECTORY "testbase"))
(define TESTBASE-TESTS-DIRECTORY (make-pathname TESTBASE-DIRECTORY "tests"))

(define-constant TESTBASE-TEST-DRIVER "chicken-testbase-driver")
(define-constant TESTBASE-TEST-DRIVER-OPTIONS "--indent 2")

;;;

(when (string>? "2.610" (chicken-version))
  (newline)
  (print "* Chicken 2.610+ needed to perform testing.")
  (exit) )

;;;

(when *verbose*
  (newline)
  (print "* Running test files" #\:) )

(define *test-driver-arguments*
  (string-append TESTBASE-TEST-DRIVER-OPTIONS (if *verbose* " -v" "")) )

; This is ungood
(define *testfiles*
  (map
    (lambda (x) (make-pathname REPOSITORY-DIRECTORY x))
    (find-files ".." ".+-test\\.scm" cons '() 0)) )

; Quote driver command for Windows.
; Test filenames CANNOT include whitespace.
(for-each
  (cut system* "\"~A\" ~A ~A" TESTBASE-TEST-DRIVER *test-driver-arguments* <>)
  *testfiles*)
